import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.lang.Math;
public class Inventory extends Menu
{
    int size;//capacity of the inventory
    Item items[];//what is in the inventory
    boolean isDrawn;
    int dim;//dimention of the square that represents an item
    int width;//width of the inventory
    int height;//height of the ENTIRE INVENTORY INCLUDEING ITEMS
    int barHeight;//height of the inventory(bar)
    public Inventory(int s, int columns, int dim)
    {
        this.dim = dim;
        size = s;
        items = new Item[size];
        isDrawn = false;
        width = columns * dim; //width must be multiple of dim, columns items in a row
        barHeight = 40;
        GreenfootImage img = getImage();
        img.scale(width, barHeight);
        height = barHeight + ((int)Math.ceil(size/(double)columns)) * dim;//columns is how many items in a row
        //height is the entire inventory including items
        fillInventory();
    }
    public void fillInventory()
    {
        for(int n = 0; n < size; n ++)
        {
            items[n] = new Item(null,this);
        }
    }//call on start up
    public void act() 
    {
        drag();
        update();
    }   
    public void interact(Item a, Item b)
    {
        //need to check to see what inventory a and b belongs, run that through if statements to decide what to do
        //for now, just for testing assume from same inventory(this) and switch the 2 items around
        int indexA = getIndexOf(a);
        int indexB = getIndexOf(b);
        if(indexA > -1 && indexB > -1)
        {
            Item temp = items[indexA];
            items[indexA] = items[indexB];
            items[indexB] = temp;
        }
    }
    public int getIndexOf(Item i)
    {
        for(int n = 0; n < size; n ++)
        {
            if(items[n] == i)
            {
                return n;
            }
        }
        return -1;
    }
    //public void interact(BuildSlot a, Item b)
    //{
    //   implement later 
    //}
    public void drag()
    {
        if(mouseOver() && leftMousePress())
        {
            //has started dragging this menu
            dragging = true;
            dragX = Greenfoot.getMouseInfo().getX() - getX();
            dragY = Greenfoot.getMouseInfo().getY() - getY();
        }
        else if(leftMouseRelease())
        {
            //dragging as ended
            dragging = false;
        }
        
        if(dragging && Greenfoot.getMouseInfo() != null)
        {
            int newX = Greenfoot.getMouseInfo().getX() - dragX;
            int newY = Greenfoot.getMouseInfo().getY() - dragY;
            if(newX - getImage().getWidth()/2 < 0)//makes sure x inbound
            {
                newX = getImage().getWidth()/2;
            }
            if(newX + getImage().getWidth()/2 > getWorld().getWidth()-1)
            {
                newX = getWorld().getWidth()-1 - getImage().getWidth()/2;
            }
            if(newY - getImage().getHeight()/2 < 0)//makes sure y inbound
            {
                newY = getImage().getHeight()/2;
            }
            if(newY + height - barHeight/2 > getWorld().getHeight()-1)
            {
                newY = getWorld().getHeight()-1 - height + barHeight/2;
            }
            
            setLocation(newX, newY);
        }
    }
    public void open()
    {
        if(!isDrawn)
        {
            for(int n = 0; n < size; n ++)
            {
                int xHelper = 0;
                int yHelper = 0;
                int x = -width/2 + dim/2;
                while(xHelper != n)
                {
                    x += dim;
                    if(x > width/2)
                    {
                        x = -width/2 + dim/2;
                        yHelper += dim;
                    }
                    xHelper ++;
                }
                x += getX();
                int y = getY() + barHeight/2 + dim/2 + yHelper;
                items[n].draw(getWorld(), x, y);
            }
            isDrawn = true;
        }
    }//if inventory is minimized, draw it
    public void update()
    {
        if(isDrawn)
        {
            Field w = (Field)getWorld();
            for(int n = 0; n < size; n ++)
            {
                if(items[n] != w.selectedItem)
                {
                    int xHelper = 0;
                    int yHelper = 0;
                    int x = -width/2 + dim/2;
                    while(xHelper != n)
                    {
                        x += dim;
                        if(x > width/2)
                        {
                            x = -width/2 + dim/2;
                            yHelper += dim;
                        }
                        xHelper ++;
                    }
                    x += getX();
                    int y = getY() + barHeight/2 + dim/2 + yHelper;
                    items[n].setLocation(x, y);
                }
            }
        }
    }//if inventory is drawn, gota update it every act
    public void close()
    {
        if(isDrawn)
        {
            isDrawn = false;
        }
    }//minimizes the inventory
}
