import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.awt.*;
public class Item extends Actor
{
    Inventory inv;//item canot exist outside of a menu(currently inventory for easy testing purposes)
    int dim;//dimention of the square
    Parts p;//what this item is
    public Item(Parts part, Inventory i)
    {
        inv = i;
        dim = i.dim;
        p = part;
        
        if(p == null)
        {
            GreenfootImage img = new GreenfootImage(dim,dim);
            //testing code
            Random rand = new Random();
            float r = rand.nextFloat();
            float g = rand.nextFloat();
            float b = rand.nextFloat();
            Color randomColor = new Color(r, g, b);
            img.setColor(randomColor);
            
            img.fillRect(0,0,dim-1,dim-1);
            //img.drawRect(0,0,dim-1,dim-1);
            setImage(img);//self explanitory
        }
        else
        {
            GreenfootImage img = p.getImage();
            img.scale(dim,dim);
            img.drawRect(0,0,dim-1,dim-1);
            setImage(img);//self explanitory
        }
    }//an item is the inventory representation of a part(think of it as bank notes)
    public void act() 
    {
        interaction();
    }    
    public void interactWith(Item i)
    {
        //depending on what inventory this item and item i is in different interactions will happen, do this by letting inv decide what to do
        inv.interact(this,i);
    }
    public void interaction()
    {
        if(Greenfoot.mousePressed(this) && Greenfoot.getMouseInfo().getButton() == 1)//leftclicked on self
        {
            Field w = (Field)getWorld();
            w.selectedItem = this;
            
            int x = getX();
            int y = getY();
            w.removeObject(this);
            w.addObject(this,x,y);//reset paint order
        }
    }
    public Parts getPart()//!!!!try returning just p!!!!
    {
        if(p == null) return null;
        return p;
    }
    public void draw(World w, int x, int y)
    {
        w.addObject(this,x,y);
    }//draw this item on the world by adding to world
    public void hide()
    {
        if(getWorld() != null)
        {
            getWorld().removeObject(this);
        }
    }//hide object by removing from world
    public boolean mouseOver()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        int mouseX = Greenfoot.getMouseInfo().getX();
        int mouseY = Greenfoot.getMouseInfo().getY();
        return mouseX > getX() - getImage().getWidth()/2 && 
               mouseX < getX() + getImage().getWidth()/2 &&
               mouseY > getY() - getImage().getHeight()/2 && 
               mouseY < getY() + getImage().getHeight()/2 ;
    }//return true if mouse is within this object('s image)
    public boolean leftMousePress()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 1 && Greenfoot.mousePressed(null);
    }
    public boolean rightMousePress()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 3 && Greenfoot.mousePressed(null);
    }
    public boolean leftMouseRelease()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 1 && Greenfoot.mouseClicked(null);
    }
    public boolean rightMouseRelease()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 3 && Greenfoot.mouseClicked(null);
    }
}
